# -*- coding: utf-8 -*-
"""
Created on Tue Apr  7 20:08:19 2020

@author: jiang
"""
import numpy as np
import glob
from astropy.time import Time

filenames = sorted(glob.glob('./*pl_201906*T00*.txt')+glob.glob('./*pl_201907*T00*.txt')+
                   glob.glob('./*pl_201908*T00*.txt')+glob.glob('./*pl_201908*T12*.txt')+
                   glob.glob('./*pl_201909*T12*.txt')+glob.glob('./*pl_201910*T12*.txt'))

t_unix = []
q0 = []
q1 = []
q2 = []
q3 = []
for i in filenames:
    f = open(i)
    data = f.readlines()
    f.close()
    data = data[0:-1:2]
    for j in range(len(data)):
        if 'start_inertial_pointing' in data[j]:
            if 'upload' in data[j-1]:
                if 'pl_' in data[j+1]:
                    if data[j-1][4] == ' ':
                        t_text = data[j-1][5:24]
                    else:
                        t_text = data[j-1][6:25]
                    t_text = t_text.replace(' ','T')
                    time_cmd_bj = Time(t_text, format='isot', scale='utc')
                    time_cmd = time_cmd_bj.unix - 3600. * 8.
                    if data[j-1][43] == ' ':
                        quat_text = data[j-1][44:-1].split(' ')
                    else:
                        quat_text = data[j-1][45:-1].split(' ')
                    tq0 = float(quat_text[0])
                    tq1 = float(quat_text[1])
                    tq2 = float(quat_text[2])
                    tq3 = np.sqrt(1 - tq0**2. - tq1**2. - tq2**2.)
                    t_unix.append(time_cmd)
                    q0.append(tq0)
                    q1.append(tq1)
                    q2.append(tq2)
                    q3.append(tq3)
                    if 'upload' in data[j+2]:
                        if data[j+2][4] == ' ':
                            t_text = data[j+2][5:24]
                        else:
                            t_text = data[j+2][6:25]
                        t_text = t_text.replace(' ','T')
                        time_cmd_bj = Time(t_text, format='isot', scale='utc')
                        time_cmd = time_cmd_bj.unix - 3600. * 8.
                        if data[j+2][43] == ' ':
                            quat_text = data[j+2][44:-1].split(' ')
                        else:
                            quat_text = data[j+2][45:-1].split(' ')
                        tq0 = float(quat_text[0])
                        tq1 = float(quat_text[1])
                        tq2 = float(quat_text[2])
                        tq3 = np.sqrt(1 - tq0**2. - tq1**2. - tq2**2.)
                        t_unix.append(time_cmd)
                        q0.append(tq0)
                        q1.append(tq1)
                        q2.append(tq2)
                        q3.append(tq3)
                        print i
        
t_unix = np.array(t_unix)
q0 = np.array(q0)
q1 = np.array(q1)
q2 = np.array(q2)
q3 = np.array(q3)

np.save('cmd_combine',[t_unix,q0,q1,q2,q3])